import '../node_modules/core-js/modules/es.date.to-string.js';
import '../node_modules/core-js/modules/es.object.to-string.js';
import '../node_modules/core-js/modules/es.reflect.construct.js';
import '../node_modules/core-js/modules/es.regexp.to-string.js';
import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent from '../BaseComponent.js';
import '../node_modules/core-js/modules/es.array.map.js';
import { Icon } from '../Icon/index.js';
import { getStyles } from './Breadcrumb.styles.js';
import { Link } from '../Link/index.js';

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var getClassNames = classNamesFunction();

var BreadcrumbBase = function (_BaseComponent) {
  _inherits(BreadcrumbBase, _BaseComponent);

  var _super = _createSuper(BreadcrumbBase);

  function BreadcrumbBase() {
    _classCallCheck(this, BreadcrumbBase);

    return _super.apply(this, arguments);
  }

  _createClass(BreadcrumbBase, [{
    key: "onBreadcrumbClicked",
    value: function onBreadcrumbClicked(event, item) {
      if (item.onClick) {
        item.onClick(event, item);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this = this;

      var h = arguments[0];
      var classNames = this.classNames,
          items = this.items;
      return h("div", {
        "class": classNames.root,
        "attrs": {
          "role": "navigation"
        }
      }, [h("ol", {
        "class": classNames.list
      }, [items.map(function (item, index) {
        return h("li", {
          "key": index,
          "class": classNames.listItem
        }, [item.onClick || item.href ? h(Link, {
          "class": classNames.itemLink,
          "attrs": {
            "href": item.href
          },
          "on": {
            "click": function click(ev) {
              return _this.onBreadcrumbClicked(ev, item);
            }
          }
        }, [item.text]) : h("span", {
          "class": classNames.item,
          "on": {
            "click": function click(ev) {
              return _this.onBreadcrumbClicked(ev, item);
            }
          }
        }, [item.text]), index !== items.length - 1 && h(Icon, {
          "key": "icon-".concat(index),
          "class": classNames.chevron,
          "attrs": {
            "icon-name": "ChevronRight"
          }
        })]);
      })])]);
    }
  }, {
    key: "classNames",
    get: function get() {
      var className = this.className,
          theme = this.theme;
      return getClassNames(getStyles, {
        theme: theme,
        className: className
      });
    }
  }]);

  return BreadcrumbBase;
}(BaseComponent);

__decorate([Prop({
  type: Array,
  required: true
}), __metadata("design:type", Array)], BreadcrumbBase.prototype, "items", void 0);

BreadcrumbBase = __decorate([Component], BreadcrumbBase);

export { BreadcrumbBase };
