import '../node_modules/core-js/modules/es.date.to-string.js';
import '../node_modules/core-js/modules/es.object.to-string.js';
import '../node_modules/core-js/modules/es.reflect.construct.js';
import '../node_modules/core-js/modules/es.regexp.to-string.js';
import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent from '../BaseComponent.js';
import '../node_modules/core-js/modules/es.symbol.js';
import '../node_modules/core-js/modules/es.array.filter.js';
import '../node_modules/core-js/modules/es.array.for-each.js';
import '../node_modules/core-js/modules/es.object.define-properties.js';
import '../node_modules/core-js/modules/es.object.define-property.js';
import '../node_modules/core-js/modules/es.object.get-own-property-descriptor.js';
import '../node_modules/core-js/modules/es.object.get-own-property-descriptors.js';
import '../node_modules/core-js/modules/es.object.keys.js';
import '../node_modules/core-js/modules/web.dom-collections.for-each.js';
import _defineProperty from '@babel/runtime/helpers/defineProperty';
import '../node_modules/core-js/modules/es.array.map.js';
import { Label } from '../Label/index.js';
import { ChoiceGroupOption } from './ChoiceGroupOption/index.js';

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var getClassNames = classNamesFunction();

var ChoiceGroupBase = function (_BaseComponent) {
  _inherits(ChoiceGroupBase, _BaseComponent);

  var _super = _createSuper(ChoiceGroupBase);

  function ChoiceGroupBase() {
    var _this;

    _classCallCheck(this, ChoiceGroupBase);

    _this = _super.apply(this, arguments);
    _this.selectedOption = {};
    return _this;
  }

  _createClass(ChoiceGroupBase, [{
    key: "onClick",
    value: function onClick(ev, option) {
      ev.preventDefault();
      if (option.disabled) return;
      this.selectedOption = option;
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var h = arguments[0];
      var classNames = this.classNames,
          label = this.label,
          required = this.required,
          disabled = this.disabled,
          selectedOption = this.selectedOption,
          options = this.options;
      return h("div", {
        "class": classNames.applicationRole
      }, [h("div", {
        "class": classNames.root
      }, [label && h(Label, {
        "class": classNames.label,
        "attrs": {
          "required": required,
          "disabled": disabled
        }
      }, [label]), h("div", {
        "class": classNames.flexContainer
      }, [options.map(function (option) {
        return h(ChoiceGroupOption, {
          "attrs": {
            "id": option.key,
            "checked": selectedOption.key === option.key
          },
          "key": option.key,
          "props": _objectSpread({}, option),
          "nativeOn": {
            "click": function click(ev) {
              return _this2.onClick(ev, option);
            }
          }
        }, [option.text]);
      })])])]);
    }
  }, {
    key: "classNames",
    get: function get() {
      var styles = this.styles,
          theme = this.theme,
          className = this.className;
      return getClassNames(styles, {
        theme: theme,
        className: className,
        optionsContainIconOrImage: false
      });
    }
  }]);

  return ChoiceGroupBase;
}(BaseComponent);

__decorate([Prop({
  type: String,
  "default": null
}), __metadata("design:type", String)], ChoiceGroupBase.prototype, "label", void 0);

__decorate([Prop({
  type: Array,
  "default": function _default() {
    return [];
  }
}), __metadata("design:type", Array)], ChoiceGroupBase.prototype, "options", void 0);

__decorate([Prop({
  type: Array,
  "default": function _default() {
    return [];
  }
}), __metadata("design:type", Array)], ChoiceGroupBase.prototype, "value", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], ChoiceGroupBase.prototype, "disabled", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], ChoiceGroupBase.prototype, "required", void 0);

ChoiceGroupBase = __decorate([Component({
  components: {
    ChoiceGroupOption: ChoiceGroupOption,
    Label: Label
  }
})], ChoiceGroupBase);

export { ChoiceGroupBase };
