import '../../node_modules/core-js/modules/es.date.to-string.js';
import '../../node_modules/core-js/modules/es.object.to-string.js';
import '../../node_modules/core-js/modules/es.reflect.construct.js';
import '../../node_modules/core-js/modules/es.regexp.to-string.js';
import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent from '../../BaseComponent.js';
import '../../node_modules/core-js/modules/es.symbol.js';
import '../../node_modules/core-js/modules/es.array.filter.js';
import '../../node_modules/core-js/modules/es.array.for-each.js';
import '../../node_modules/core-js/modules/es.object.define-properties.js';
import '../../node_modules/core-js/modules/es.object.define-property.js';
import '../../node_modules/core-js/modules/es.object.get-own-property-descriptor.js';
import '../../node_modules/core-js/modules/es.object.get-own-property-descriptors.js';
import '../../node_modules/core-js/modules/es.object.keys.js';
import '../../node_modules/core-js/modules/web.dom-collections.for-each.js';
import _defineProperty from '@babel/runtime/helpers/defineProperty';
import _mergeJSXProps from '../../node_modules/@vue/babel-helper-vue-jsx-merge-props/dist/helper.js';
import { DetailsRowFields } from './DetailsRowFields.js';

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var getClassNames = classNamesFunction();
var NO_COLUMNS = [];

var DetailsRowBase = function (_BaseComponent) {
  _inherits(DetailsRowBase, _BaseComponent);

  var _super = _createSuper(DetailsRowBase);

  function DetailsRowBase() {
    var _this;

    _classCallCheck(this, DetailsRowBase);

    _this = _super.apply(this, arguments);
    _this.showCheckbox = false;
    return _this;
  }

  _createClass(DetailsRowBase, [{
    key: "measureCell",
    value: function measureCell(index, onMeasureDone) {
      var _this$columns = this.columns,
          columns = _this$columns === void 0 ? NO_COLUMNS : _this$columns;

      var column = _objectSpread({}, columns[index]);

      column.minWidth = 0;
      column.maxWidth = 999999;
      delete column.calculatedWidth;
    }
  }, {
    key: "render",
    value: function render() {
      var h = arguments[0];
      var classNames = this.classNames,
          rowClassNames = this.rowClassNames,
          item = this.item,
          columns = this.columns,
          showCheckbox = this.showCheckbox;
      return h("div", {
        "class": classNames.root
      }, [h(DetailsRowFields, _mergeJSXProps([{
        "attrs": {
          "row-class-names": rowClassNames,
          "columns": columns,
          "item": item,
          "item-index": 0,
          "column-start-index": showCheckbox ? 1 : 0
        }
      }, {
        scopedSlots: this.$scopedSlots
      }]))]);
    }
  }, {
    key: "classNames",
    get: function get() {
      var styles = this.styles,
          theme = this.theme,
          className = this.className,
          compact = this.compact;
      return _objectSpread({}, getClassNames(styles, {
        theme: theme,
        isSelected: false,
        canSelect: false,
        anySelected: false,
        checkboxCellClassName: '',
        droppingClassName: '',
        className: className,
        compact: compact,
        enableUpdateAnimations: false
      }));
    }
  }, {
    key: "rowClassNames",
    get: function get() {
      return {
        isMultiline: this.classNames.isMultiline,
        isRowHeader: this.classNames.isRowHeader,
        cell: this.classNames.cell,
        cellAnimation: this.classNames.cellAnimation,
        cellPadded: this.classNames.cellPadded,
        cellUnpadded: this.classNames.cellUnpadded,
        fields: this.classNames.fields
      };
    }
  }]);

  return DetailsRowBase;
}(BaseComponent);

__decorate([Prop({
  type: Array,
  required: true
}), __metadata("design:type", Array)], DetailsRowBase.prototype, "columns", void 0);

__decorate([Prop({
  type: Object,
  required: true
}), __metadata("design:type", Object)], DetailsRowBase.prototype, "item", void 0);

__decorate([Prop({
  type: Boolean,
  required: true
}), __metadata("design:type", Boolean)], DetailsRowBase.prototype, "compact", void 0);

DetailsRowBase = __decorate([Component], DetailsRowBase);

export { DetailsRowBase };
