import { getGlobalClassNames, ScreenWidthMinMedium } from '@uifabric/styling';
import _defineProperty from '@babel/runtime/helpers/defineProperty';

var GlobalClassNames = {
  root: 'ms-Dialog'
};
var getStyles = function getStyles(props) {
  var className = props.className,
      _props$dialogDefaultM = props.dialogDefaultMinWidth,
      dialogDefaultMinWidth = _props$dialogDefaultM === void 0 ? '288px' : _props$dialogDefaultM,
      _props$dialogDefaultM2 = props.dialogDefaultMaxWidth,
      dialogDefaultMaxWidth = _props$dialogDefaultM2 === void 0 ? '340px' : _props$dialogDefaultM2,
      hidden = props.hidden,
      theme = props.theme;
  var classNames = getGlobalClassNames(GlobalClassNames, theme);
  return {
    root: [classNames.root, theme.fonts.medium, className],
    main: [{
      width: dialogDefaultMinWidth,
      outline: '3px solid transparent',
      selectors: _defineProperty({}, "@media (min-width: ".concat(ScreenWidthMinMedium, "px)"), {
        width: 'auto',
        maxWidth: dialogDefaultMaxWidth,
        minWidth: dialogDefaultMinWidth
      })
    }, !hidden && {
      display: 'flex'
    }]
  };
};

export { getStyles };
