import '../node_modules/core-js/modules/es.date.to-string.js';
import '../node_modules/core-js/modules/es.object.to-string.js';
import '../node_modules/core-js/modules/es.reflect.construct.js';
import '../node_modules/core-js/modules/es.regexp.to-string.js';
import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent from '../BaseComponent.js';
import '../node_modules/core-js/modules/es.symbol.js';
import '../node_modules/core-js/modules/es.array.filter.js';
import '../node_modules/core-js/modules/es.array.for-each.js';
import '../node_modules/core-js/modules/es.object.define-properties.js';
import '../node_modules/core-js/modules/es.object.define-property.js';
import '../node_modules/core-js/modules/es.object.get-own-property-descriptor.js';
import '../node_modules/core-js/modules/es.object.get-own-property-descriptors.js';
import '../node_modules/core-js/modules/es.object.keys.js';
import '../node_modules/core-js/modules/web.dom-collections.for-each.js';
import _defineProperty from '@babel/runtime/helpers/defineProperty';
import '../node_modules/core-js/modules/es.array.map.js';
import '../node_modules/core-js/modules/es.number.constructor.js';
import { PersonaSize } from '../Persona/Persona.types.js';
import { FacepileButton } from './FacepileButton/FacepileButton.js';
import { Persona } from '../Persona/index.js';

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var getClassNames = classNamesFunction();

var FacepileBase = function (_BaseComponent) {
  _inherits(FacepileBase, _BaseComponent);

  var _super = _createSuper(FacepileBase);

  function FacepileBase() {
    _classCallCheck(this, FacepileBase);

    return _super.apply(this, arguments);
  }

  _createClass(FacepileBase, [{
    key: "render",
    value: function render() {
      var h = arguments[0];
      var classNames = this.classNames,
          personas = this.personas,
          singlePersona = this.singlePersona,
          personaSize = this.personaSize;
      return h("div", {
        "class": classNames.root
      }, [h("div", {
        "class": classNames.itemContainer
      }, [h("ul", {
        "class": classNames.members,
        "attrs": {
          "role": "listbox"
        }
      }, [personas.map(function (persona, index) {
        return h("li", {
          "key": singlePersona ? 'persona' : "personaCoin-".concat(index),
          "class": classNames.member,
          "attrs": {
            "role": "option"
          }
        }, [h("div", {
          "class": classNames.itemButton,
          "attrs": {
            "title": persona.personaName
          }
        }, [h(Persona, {
          "props": _objectSpread({}, persona),
          "attrs": {
            "image-initials": persona.imageInitials,
            "image-url": persona.imageUrl,
            "initials-color": persona.initialsColor,
            "allow-phone-initials": persona.allowPhoneInitials,
            "text": persona.personaName,
            "presence": 2,
            "size": personaSize,
            "styles": {
              details: {
                flex: '1 0 auto'
              }
            }
          }
        })])]);
      })])])]);
    }
  }, {
    key: "singlePersona",
    get: function get() {
      return this.personas.length === 1;
    }
  }, {
    key: "classNames",
    get: function get() {
      return getClassNames(this.styles, {
        theme: this.theme,
        className: this.className
      });
    }
  }]);

  return FacepileBase;
}(BaseComponent);

__decorate([Prop({
  type: Array,
  "default": function _default() {
    return [];
  }
}), __metadata("design:type", Array)], FacepileBase.prototype, "personas", void 0);

__decorate([Prop({
  type: Number,
  "default": PersonaSize.size32
}), __metadata("design:type", Number)], FacepileBase.prototype, "personaSize", void 0);

FacepileBase = __decorate([Component({
  components: {
    FacepileButton: FacepileButton,
    Persona: Persona
  }
})], FacepileBase);

export { FacepileBase };
