import '../node_modules/core-js/modules/es.date.to-string.js';
import '../node_modules/core-js/modules/es.object.to-string.js';
import '../node_modules/core-js/modules/es.reflect.construct.js';
import '../node_modules/core-js/modules/es.regexp.to-string.js';
import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import BaseComponent from '../BaseComponent.js';
import { notifyHostChanged } from './Layer.notification.js';

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var LayerHost = function (_BaseComponent) {
  _inherits(LayerHost, _BaseComponent);

  var _super = _createSuper(LayerHost);

  function LayerHost() {
    _classCallCheck(this, LayerHost);

    return _super.apply(this, arguments);
  }

  _createClass(LayerHost, [{
    key: "render",
    value: function render() {
      var h = arguments[0];
      return h("div", {
        "attrs": {
          "id": this.hostId
        },
        "class": "LayerHost"
      });
    }
  }, {
    key: "mounted",
    value: function mounted() {
      notifyHostChanged(this.hostId);
    }
  }, {
    key: "beforeDestroy",
    value: function beforeDestroy() {
      notifyHostChanged(this.hostId);
    }
  }]);

  return LayerHost;
}(BaseComponent);

__decorate([Prop({
  type: String,
  "default": null
}), __metadata("design:type", String)], LayerHost.prototype, "hostId", void 0);

LayerHost = __decorate([Component({
  components: {}
})], LayerHost);

export { LayerHost };
