import '../node_modules/core-js/modules/es.date.to-string.js';
import '../node_modules/core-js/modules/es.object.to-string.js';
import '../node_modules/core-js/modules/es.reflect.construct.js';
import '../node_modules/core-js/modules/es.regexp.to-string.js';
import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent from '../BaseComponent.js';
import '../node_modules/core-js/modules/es.symbol.js';
import '../node_modules/core-js/modules/es.symbol.description.js';
import '../node_modules/core-js/modules/es.number.constructor.js';

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var getClassNames = classNamesFunction();
var ZERO_THRESHOLD = 0.01;

var ProgressIndicatorBase = function (_BaseComponent) {
  _inherits(ProgressIndicatorBase, _BaseComponent);

  var _super = _createSuper(ProgressIndicatorBase);

  function ProgressIndicatorBase() {
    _classCallCheck(this, ProgressIndicatorBase);

    return _super.apply(this, arguments);
  }

  _createClass(ProgressIndicatorBase, [{
    key: "render",
    value: function render() {
      var h = arguments[0];
      var classNames = this.classNames,
          label = this.label,
          progressHidden = this.progressHidden,
          progressBarStyles = this.progressBarStyles,
          description = this.description;
      return h("div", {
        "class": classNames.root
      }, [label && h("div", {
        "class": classNames.itemName
      }, [label]), !progressHidden && h("div", {
        "class": classNames.itemProgress
      }, [h("div", {
        "class": classNames.progressTrack
      }), h("div", {
        "class": classNames.progressBar,
        "style": progressBarStyles
      })]), description && h("div", {
        "class": classNames.itemDescription
      }, [description])]);
    }
  }, {
    key: "classNames",
    get: function get() {
      var className = this.className,
          indeterminate = this.indeterminate,
          theme = this.theme,
          barHeight = this.barHeight;
      return getClassNames(this.styles, {
        className: className,
        indeterminate: indeterminate,
        theme: theme,
        barHeight: barHeight
      });
    }
  }, {
    key: "progressBarStyles",
    get: function get() {
      var percentComplete = this.percentComplete;
      return {
        width: percentComplete !== undefined ? percentComplete + '%' : undefined,
        transition: percentComplete !== undefined && percentComplete < ZERO_THRESHOLD ? 'none' : undefined
      };
    }
  }]);

  return ProgressIndicatorBase;
}(BaseComponent);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], ProgressIndicatorBase.prototype, "progressHidden", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], ProgressIndicatorBase.prototype, "indeterminate", void 0);

__decorate([Prop({
  type: Number,
  "default": 0
}), __metadata("design:type", Number)], ProgressIndicatorBase.prototype, "percentComplete", void 0);

__decorate([Prop({
  type: String,
  "default": null
}), __metadata("design:type", String)], ProgressIndicatorBase.prototype, "label", void 0);

__decorate([Prop({
  type: String,
  "default": null
}), __metadata("design:type", String)], ProgressIndicatorBase.prototype, "description", void 0);

__decorate([Prop({
  type: Number,
  "default": 2
}), __metadata("design:type", Number)], ProgressIndicatorBase.prototype, "barHeight", void 0);

ProgressIndicatorBase = __decorate([Component], ProgressIndicatorBase);

export { ProgressIndicatorBase };
