import '../node_modules/core-js/modules/es.date.to-string.js';
import '../node_modules/core-js/modules/es.object.to-string.js';
import '../node_modules/core-js/modules/es.reflect.construct.js';
import '../node_modules/core-js/modules/es.regexp.to-string.js';
import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import { mergeStyleSets } from '@uifabric/styling';
import '../node_modules/core-js/modules/es.symbol.js';
import '../node_modules/core-js/modules/es.array.filter.js';
import '../node_modules/core-js/modules/es.array.for-each.js';
import '../node_modules/core-js/modules/es.object.define-properties.js';
import '../node_modules/core-js/modules/es.object.define-property.js';
import '../node_modules/core-js/modules/es.object.get-own-property-descriptor.js';
import '../node_modules/core-js/modules/es.object.get-own-property-descriptors.js';
import '../node_modules/core-js/modules/es.object.keys.js';
import '../node_modules/core-js/modules/web.dom-collections.for-each.js';
import _defineProperty from '@babel/runtime/helpers/defineProperty';
import StatelessComponent from '../StatelessComponent.js';
import '../node_modules/core-js/modules/es.number.constructor.js';
import { styles } from './Stack.styles.js';

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var getClassNames = classNamesFunction();

var Stack = function (_StatelessComponent) {
  _inherits(Stack, _StatelessComponent);

  var _super = _createSuper(Stack);

  function Stack() {
    _classCallCheck(this, Stack);

    return _super.apply(this, arguments);
  }

  _createClass(Stack, [{
    key: "render",
    value: function render(h, ctx) {
      var _ctx$props = ctx.props,
          theme = _ctx$props.theme,
          tokens = _ctx$props.tokens,
          verticalFill = _ctx$props.verticalFill,
          horizontal = _ctx$props.horizontal,
          reversed = _ctx$props.reversed,
          grow = _ctx$props.grow,
          wrap = _ctx$props.wrap,
          horizontalAlign = _ctx$props.horizontalAlign,
          verticalAlign = _ctx$props.verticalAlign,
          disableShrink = _ctx$props.disableShrink,
          className = _ctx$props.className;
      var classNames = getClassNames(mergeStyleSets(styles({
        className: className,
        verticalFill: verticalFill,
        horizontal: horizontal,
        reversed: reversed,
        grow: grow,
        wrap: wrap,
        horizontalAlign: horizontalAlign,
        verticalAlign: verticalAlign,
        disableShrink: disableShrink
      }, theme, tokens), ctx.props.styles));
      return h('div', _objectSpread(_objectSpread({}, ctx.data), {}, {
        "class": classNames.root
      }), ctx.children);
    }
  }]);

  return Stack;
}(StatelessComponent);

__decorate([Prop({
  type: String,
  "default": ''
}), __metadata("design:type", String)], Stack.prototype, "verticalFill", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], Stack.prototype, "horizontal", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], Stack.prototype, "reversed", void 0);

__decorate([Prop({
  type: Number,
  "default": 0
}), __metadata("design:type", Number)], Stack.prototype, "childrenGap", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], Stack.prototype, "grow", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], Stack.prototype, "wrap", void 0);

__decorate([Prop({
  type: String,
  "default": ''
}), __metadata("design:type", String)], Stack.prototype, "horizontalAlign", void 0);

__decorate([Prop({
  type: String,
  "default": ''
}), __metadata("design:type", String)], Stack.prototype, "verticalAlign", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], Stack.prototype, "disableShrink", void 0);

__decorate([Prop({
  type: Object,
  "default": function _default() {}
}), __metadata("design:type", Object)], Stack.prototype, "tokens", void 0);

Stack = __decorate([Component({
  components: {}
})], Stack);

export { Stack };
