import '../node_modules/core-js/modules/es.date.to-string.js';
import '../node_modules/core-js/modules/es.object.to-string.js';
import '../node_modules/core-js/modules/es.reflect.construct.js';
import '../node_modules/core-js/modules/es.regexp.to-string.js';
import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate, __metadata } from 'tslib';
import { Prop, Watch, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent from '../BaseComponent.js';
import '../node_modules/core-js/modules/es.symbol.js';
import '../node_modules/core-js/modules/es.array.filter.js';
import '../node_modules/core-js/modules/es.array.for-each.js';
import '../node_modules/core-js/modules/es.object.define-properties.js';
import '../node_modules/core-js/modules/es.object.define-property.js';
import '../node_modules/core-js/modules/es.object.get-own-property-descriptor.js';
import '../node_modules/core-js/modules/es.object.get-own-property-descriptors.js';
import '../node_modules/core-js/modules/es.object.keys.js';
import '../node_modules/core-js/modules/web.dom-collections.for-each.js';
import _defineProperty from '@babel/runtime/helpers/defineProperty';
import '../node_modules/core-js/modules/es.symbol.description.js';
import { Label } from '../Label/index.js';
import '../node_modules/core-js/modules/es.promise.js';
import _regeneratorRuntime from '@babel/runtime/regenerator';
import '../node_modules/regenerator-runtime/runtime.js';
import _asyncToGenerator from '@babel/runtime/helpers/asyncToGenerator';

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var getClassNames = classNamesFunction();

var TextFieldBase = function (_BaseComponent) {
  _inherits(TextFieldBase, _BaseComponent);

  var _super = _createSuper(TextFieldBase);

  function TextFieldBase() {
    var _this;

    _classCallCheck(this, TextFieldBase);

    _this = _super.apply(this, arguments);
    _this.isActive = false;
    _this.internalValue = _this.value;
    return _this;
  }

  _createClass(TextFieldBase, [{
    key: "mounted",
    value: function mounted() {
      this.adjustInputHeight();
    }
  }, {
    key: "updated",
    value: function updated() {
      this.adjustInputHeight();
    }
  }, {
    key: "onPropValueChanged",
    value: function onPropValueChanged(newValue) {
      this.internalValue = newValue;
    }
  }, {
    key: "onMultilineChanged",
    value: function () {
      var _onMultilineChanged = _asyncToGenerator(_regeneratorRuntime.mark(function _callee(newValue, oldValue) {
        var textElement, start, end;
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                textElement = this.$refs.textElement;
                start = textElement.selectionStart || 0;
                end = textElement.selectionEnd || 0;

                if (!(newValue !== oldValue && this.isActive)) {
                  _context.next = 8;
                  break;
                }

                _context.next = 6;
                return this.$nextTick();

              case 6:
                this.$refs.textElement.focus();
                this.$refs.textElement.setSelectionRange(start, end);

              case 8:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function onMultilineChanged(_x, _x2) {
        return _onMultilineChanged.apply(this, arguments);
      }

      return onMultilineChanged;
    }()
  }, {
    key: "adjustInputHeight",
    value: function adjustInputHeight() {
      if (this.$refs.textElement && this.autoAdjustHeight && this.multiline) {
        var textField = this.$refs.textElement;
        textField.style.height = '';
        textField.style.height = textField.scrollHeight + 'px';
      }
    }
  }, {
    key: "onFocus",
    value: function () {
      var _onFocus = _asyncToGenerator(_regeneratorRuntime.mark(function _callee2() {
        return _regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                this.isActive = true;
                this.$refs.textElement.setSelectionRange(this.internalValue.length, this.internalValue.length);

              case 2:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function onFocus() {
        return _onFocus.apply(this, arguments);
      }

      return onFocus;
    }()
  }, {
    key: "onInput",
    value: function onInput(ev, value) {
      this.internalValue = value;
      this.$emit('input', value);
      this.$emit('change', ev, value);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var h = arguments[0];
      var classNames = this.classNames,
          required = this.required,
          label = this.label,
          errorMessage = this.errorMessage,
          disabled = this.disabled,
          multiline = this.multiline,
          internalValue = this.internalValue,
          readonly = this.readonly,
          placeholder = this.placeholder,
          resizable = this.resizable;
      var Component = multiline ? 'textarea' : 'input';
      var labelStyles = classNames.subComponentStyles ? classNames.subComponentStyles.label : undefined;
      return h("div", {
        "class": classNames.root
      }, [h("div", {
        "class": classNames.wrapper
      }, [label && h(Label, {
        "attrs": {
          "styles": labelStyles,
          "for": "TextField".concat(this.uid),
          "required": required
        }
      }, [label]), h("div", {
        "class": classNames.fieldGroup
      }, [h(Component, {
        "attrs": _objectSpread(_objectSpread({
          "id": this.$attrs.id || "TextField".concat(this.uid),
          "value": internalValue
        }, this.$attrs), {}, {
          "disabled": disabled,
          "readonly": readonly,
          "required": required,
          "placeholder": placeholder,
          "rows": +this.$attrs.rows || 1,
          "type": "text",
          "autocomplete": "off"
        }),
        "ref": "textElement",
        "class": classNames.field,
        "style": {
          resize: resizable === false && 'none'
        },
        "on": {
          "focus": this.onFocus,
          "blur": function blur() {
            return _this2.isActive = false;
          },
          "input": function input(ev) {
            return _this2.onInput(ev, ev.target.value);
          }
        }
      }, [internalValue])])]), errorMessage && h("div", {
        "class": classNames.description
      }, [h("div", {
        "attrs": {
          "role": "alert"
        }
      }, [h("p", {
        "class": classNames.errorMessage
      }, [h("span", [errorMessage])])])])]);
    }
  }, {
    key: "classNames",
    get: function get() {
      var theme = this.theme,
          className = this.className,
          disabled = this.disabled,
          focused = this.isActive,
          required = this.required,
          multiline = this.multiline,
          label = this.label,
          borderless = this.borderless,
          underlined = this.underlined,
          resizable = this.resizable,
          autoAdjustHeight = this.autoAdjustHeight;
      return getClassNames(this.styles, {
        theme: theme,
        className: className,
        disabled: disabled,
        focused: focused,
        required: required,
        multiline: multiline,
        hasLabel: !!label,
        borderless: borderless,
        underlined: underlined,
        hasIcon: false,
        resizable: resizable !== false,
        hasErrorMessage: !!this.errorMessage,
        inputClassName: '',
        autoAdjustHeight: autoAdjustHeight
      });
    }
  }]);

  return TextFieldBase;
}(BaseComponent);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], TextFieldBase.prototype, "multiline", void 0);

__decorate([Prop({
  type: Boolean,
  "default": null
}), __metadata("design:type", Boolean)], TextFieldBase.prototype, "resizable", void 0);

__decorate([Prop({
  type: Boolean,
  "default": null
}), __metadata("design:type", Boolean)], TextFieldBase.prototype, "autoAdjustHeight", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], TextFieldBase.prototype, "borderless", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], TextFieldBase.prototype, "disabled", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], TextFieldBase.prototype, "underlined", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], TextFieldBase.prototype, "readonly", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], TextFieldBase.prototype, "required", void 0);

__decorate([Prop({
  type: String,
  "default": null
}), __metadata("design:type", String)], TextFieldBase.prototype, "label", void 0);

__decorate([Prop({
  type: String,
  "default": ''
}), __metadata("design:type", String)], TextFieldBase.prototype, "value", void 0);

__decorate([Prop({
  type: String,
  "default": null
}), __metadata("design:type", String)], TextFieldBase.prototype, "errorMessage", void 0);

__decorate([Prop({
  type: String,
  "default": null
}), __metadata("design:type", String)], TextFieldBase.prototype, "placeholder", void 0);

__decorate([Prop({
  type: String,
  "default": null
}), __metadata("design:type", String)], TextFieldBase.prototype, "description", void 0);

__decorate([Watch('value'), __metadata("design:type", Function), __metadata("design:paramtypes", [String]), __metadata("design:returntype", void 0)], TextFieldBase.prototype, "onPropValueChanged", null);

__decorate([Watch('multiline'), __metadata("design:type", Function), __metadata("design:paramtypes", [Boolean, Boolean]), __metadata("design:returntype", Promise)], TextFieldBase.prototype, "onMultilineChanged", null);

TextFieldBase = __decorate([Component({
  components: {
    Label: Label
  },
  inheritAttrs: false
})], TextFieldBase);

export { TextFieldBase };
