import StatelessComponent from '../StatelessComponent';
import { classNamesFunction } from '@uifabric-vue/utilities';
const getClassNames = classNamesFunction();
export class VerticalDividerBase extends StatelessComponent {
    render(h, ctx) {
        const { styles, theme, className } = ctx.props;
        const classNames = getClassNames(styles, { theme: theme, className });
        return (<span class={classNames.wrapper}>
        <span class={classNames.divider}/>
      </span>);
    }
}
//# sourceMappingURL=VerticalDivider.base.jsx.map