import { __decorate } from "tslib";
import { classNamesFunction } from '@uifabric-vue/utilities';
import StatelessComponent from '../../StatelessComponent';
import { Component } from 'vue-property-decorator';
import { ShimmerElementsDefaultHeights } from '../Shimmer.types';
import { ShimmerLine } from '../ShimmerLine/ShimmerLine';
const getClassNames = classNamesFunction();
let ShimmerElementsGroupBase = class ShimmerElementsGroupBase extends StatelessComponent {
    // @Prop()
    render(h, ctx) {
        const { styles, theme, } = ctx.props;
        const classNames = getClassNames(styles, {
            theme,
        });
        return (<div class={classNames.root}>
        <shimmer-line height={ShimmerElementsDefaultHeights.line}/>
      </div>);
    }
};
ShimmerElementsGroupBase = __decorate([
    Component({
        components: {
            ShimmerLine,
        },
    })
], ShimmerElementsGroupBase);
export default ShimmerElementsGroupBase;
//# sourceMappingURL=ShimmerElementsGroup.base.jsx.map