import { __decorate, __metadata } from "tslib";
import { Vue, Prop, Component } from 'vue-property-decorator';
import { css } from '@uifabric-vue/utilities';
import { getTheme } from '@uifabric/styling';
// @ts-ignore
let StatelessComponent = class StatelessComponent extends Vue {
    css() {
        return css(...arguments);
    }
};
__decorate([
    Prop({ type: [String, Array], default: '' }),
    __metadata("design:type", String)
], StatelessComponent.prototype, "className", void 0);
__decorate([
    Prop({ type: [Object, Function], default: () => { } }),
    __metadata("design:type", Object)
], StatelessComponent.prototype, "styles", void 0);
__decorate([
    Prop({ type: Object, default: () => getTheme() }),
    __metadata("design:type", Object)
], StatelessComponent.prototype, "theme", void 0);
StatelessComponent = __decorate([
    Component({
        // @ts-ignore
        functional: true,
        provide: {},
    })
], StatelessComponent);
export default StatelessComponent;
//# sourceMappingURL=StatelessComponent.js.map