import { getGlobalClassNames } from '@uifabric/styling';
const GlobalClassNames = {
    focusedContainer: 'ms-swatchColorPickerBodyContainer',
};
export const getStyles = (props) => {
    const { className, theme, cellMargin } = props;
    const classNames = getGlobalClassNames(GlobalClassNames, theme);
    return {
        root: {
            margin: '8px 0',
            borderCollapse: 'collapse',
        },
        tableCell: {
            padding: cellMargin / 2,
        },
        focusedContainer: [
            classNames.focusedContainer,
            {
                clear: 'both',
                display: 'block',
                minWidth: '180px',
            },
            className,
        ],
    };
};
//# sourceMappingURL=SwatchColorPicker.styles.js.map