import './node_modules/core-js/modules/es.date.to-string.js';
import './node_modules/core-js/modules/es.object.to-string.js';
import './node_modules/core-js/modules/es.reflect.construct.js';
import './node_modules/core-js/modules/es.regexp.to-string.js';
import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate, __metadata } from 'tslib';
import { Vue, Prop, Component } from 'vue-property-decorator';
import { css, Async, EventGroup } from '@uifabric-vue/utilities';
import { getTheme } from '@uifabric/styling';

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var BaseComponent = function (_Vue) {
  _inherits(BaseComponent, _Vue);

  var _super = _createSuper(BaseComponent);

  function BaseComponent() {
    var _this;

    _classCallCheck(this, BaseComponent);

    _this = _super.apply(this, arguments);
    _this.componentRef = null;
    _this.css = css;
    _this.__async = null;
    _this.__events = null;
    _this.__disposables = null;
    _this.state = {};
    _this.props = {};
    return _this;
  }

  _createClass(BaseComponent, [{
    key: "mounted",
    value: function mounted() {
      this.componentRef = this.$el;
    }
  }, {
    key: "beforeDestroy",
    value: function beforeDestroy() {
      if (this.__disposables) {
        for (var i = 0, len = this._disposables.length; i < len; i++) {
          var disposable = this.__disposables[i];

          if (disposable.dispose) {
            disposable.dispose();
          }
        }

        this.__disposables = null;
      }
    }
  }, {
    key: "setState",
    value: function setState(newState) {
      for (var key in newState) {
        this.$set(this.state, key, newState[key]);
      }

      return this.state;
    }
  }, {
    key: "uid",
    get: function get() {
      return this._uid;
    }
  }, {
    key: "classNames",
    get: function get() {
      return {};
    }
  }, {
    key: "_disposables",
    get: function get() {
      if (!this.__disposables) {
        this.__disposables = [];
      }

      return this.__disposables;
    }
  }, {
    key: "_async",
    get: function get() {
      if (!this.__async) {
        this.__async = new Async(this);

        this._disposables.push(this.__async);
      }

      return this.__async;
    }
  }, {
    key: "events",
    get: function get() {
      if (!this.__events) {
        this.__events = new EventGroup(this);

        this._disposables.push(this.__events);
      }

      return this.__events;
    }
  }]);

  return BaseComponent;
}(Vue);

__decorate([Prop({
  type: [String, Array],
  "default": ''
}), __metadata("design:type", String)], BaseComponent.prototype, "className", void 0);

__decorate([Prop({
  type: [Object, Function],
  "default": function _default() {}
}), __metadata("design:type", Object)], BaseComponent.prototype, "styles", void 0);

__decorate([Prop({
  type: Object,
  "default": function _default() {
    return getTheme();
  }
}), __metadata("design:type", Object)], BaseComponent.prototype, "theme", void 0);

BaseComponent = __decorate([Component], BaseComponent);
var BaseComponent$1 = BaseComponent;

export default BaseComponent$1;
