import '../../node_modules/core-js/modules/es.array.concat.js';
import '../../node_modules/core-js/modules/es.date.to-string.js';
import '../../node_modules/core-js/modules/es.object.to-string.js';
import '../../node_modules/core-js/modules/es.reflect.construct.js';
import '../../node_modules/core-js/modules/es.regexp.to-string.js';
import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent from '../../BaseComponent.js';
import '../../node_modules/core-js/modules/es.symbol.js';
import '../../node_modules/core-js/modules/es.array.filter.js';
import '../../node_modules/core-js/modules/es.array.for-each.js';
import '../../node_modules/core-js/modules/es.object.define-properties.js';
import '../../node_modules/core-js/modules/es.object.define-property.js';
import '../../node_modules/core-js/modules/es.object.get-own-property-descriptor.js';
import '../../node_modules/core-js/modules/es.object.get-own-property-descriptors.js';
import '../../node_modules/core-js/modules/es.object.keys.js';
import '../../node_modules/core-js/modules/web.dom-collections.for-each.js';
import _defineProperty from '@babel/runtime/helpers/defineProperty';
import { Image } from '../../Image/index.js';
import { Icon } from '../../Icon/index.js';

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var getClassNames = classNamesFunction();

var ChoiceGroupOptionBase = function (_BaseComponent) {
  _inherits(ChoiceGroupOptionBase, _BaseComponent);

  var _super = _createSuper(ChoiceGroupOptionBase);

  function ChoiceGroupOptionBase() {
    _classCallCheck(this, ChoiceGroupOptionBase);

    return _super.apply(this, arguments);
  }

  _createClass(ChoiceGroupOptionBase, [{
    key: "render",
    value: function render() {
      var h = arguments[0];
      var id = this.id,
          classNames = this.classNames,
          text = this.text,
          imageSrc = this.imageSrc,
          imageAlt = this.imageAlt,
          imageSize = this.imageSize,
          selectedImageSrc = this.selectedImageSrc,
          iconProps = this.iconProps,
          disabled = this.disabled;
      return h("div", {
        "class": classNames.root
      }, [h("div", {
        "class": classNames.choiceFieldWrapper
      }, [h("input", {
        "attrs": {
          "id": "ChoiceGroup".concat(this.uid, "-").concat(id),
          "name": "ChoiceGroup".concat(this.uid),
          "disabled": this.disabled,
          "type": "radio"
        },
        "class": classNames.input
      }), h("label", {
        "attrs": {
          "for": "ChoiceGroup".concat(this.uid, "-").concat(id)
        },
        "class": classNames.field
      }, [imageSrc && h("div", {
        "class": classNames.innerField
      }, [h("div", {
        "class": classNames.imageWrapper
      }, [h(Image, {
        "attrs": {
          "src": imageSrc,
          "alt": imageAlt,
          "width": imageSize.width,
          "height": imageSize.height
        }
      })]), h("div", {
        "class": classNames.selectedImageWrapper
      }, [h(Image, {
        "attrs": {
          "src": selectedImageSrc,
          "alt": imageAlt,
          "width": imageSize.width,
          "height": imageSize.height
        }
      })])]), iconProps && h("div", {
        "class": classNames.innerField
      }, [h("div", {
        "class": classNames.iconWrapper
      }, [h(Icon, {
        "props": _objectSpread({}, iconProps)
      })])]), imageSrc || iconProps ? h("div", {
        "class": classNames.labelWrapper
      }, [h("span", {
        "class": "ms-ChoiceFieldLabel"
      }, [this.$slots["default"] || text])]) : h("span", {
        "class": "ms-ChoiceFieldLabel"
      }, [this.$slots["default"] || text])])])]);
    }
  }, {
    key: "classNames",
    get: function get() {
      var styles = this.styles,
          theme = this.theme,
          iconProps = this.iconProps,
          imageSrc = this.imageSrc,
          checked = this.checked,
          disabled = this.disabled,
          imageSize = this.imageSize,
          focused = this.focused;
      return getClassNames(styles, {
        theme: theme,
        hasIcon: !!iconProps,
        hasImage: !!imageSrc,
        checked: checked,
        disabled: disabled,
        imageIsLarge: !!imageSrc && (imageSize.width > 71 || imageSize.height > 71),
        imageSize: imageSize,
        focused: focused
      });
    }
  }]);

  return ChoiceGroupOptionBase;
}(BaseComponent);

__decorate([Prop(), __metadata("design:type", String)], ChoiceGroupOptionBase.prototype, "id", void 0);

__decorate([Prop(), __metadata("design:type", String)], ChoiceGroupOptionBase.prototype, "text", void 0);

__decorate([Prop(), __metadata("design:type", Object)], ChoiceGroupOptionBase.prototype, "iconProps", void 0);

__decorate([Prop(), __metadata("design:type", Object)], ChoiceGroupOptionBase.prototype, "imageSrc", void 0);

__decorate([Prop(), __metadata("design:type", Object)], ChoiceGroupOptionBase.prototype, "selectedImageSrc", void 0);

__decorate([Prop(), __metadata("design:type", Object)], ChoiceGroupOptionBase.prototype, "imageAlt", void 0);

__decorate([Prop(), __metadata("design:type", Boolean)], ChoiceGroupOptionBase.prototype, "checked", void 0);

__decorate([Prop(), __metadata("design:type", Boolean)], ChoiceGroupOptionBase.prototype, "disabled", void 0);

__decorate([Prop({
  "default": function _default() {
    return {
      width: 32,
      height: 32
    };
  }
}), __metadata("design:type", Object)], ChoiceGroupOptionBase.prototype, "imageSize", void 0);

__decorate([Prop(), __metadata("design:type", Boolean)], ChoiceGroupOptionBase.prototype, "focused", void 0);

ChoiceGroupOptionBase = __decorate([Component], ChoiceGroupOptionBase);

export { ChoiceGroupOptionBase };
