import '../node_modules/core-js/modules/es.date.to-string.js';
import '../node_modules/core-js/modules/es.object.to-string.js';
import '../node_modules/core-js/modules/es.reflect.construct.js';
import '../node_modules/core-js/modules/es.regexp.to-string.js';
import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent from '../BaseComponent.js';
import '../node_modules/core-js/modules/es.function.name.js';
import _mergeJSXProps from '../node_modules/@vue/babel-helper-vue-jsx-merge-props/dist/helper.js';
import Icon from '../Icon/Icon.js';
import '../node_modules/core-js/modules/es.regexp.exec.js';
import '../node_modules/core-js/modules/es.string.split.js';
import _assertThisInitialized from '@babel/runtime/helpers/assertThisInitialized';

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var getClassNames = classNamesFunction();

var ContextualMenuItem = function (_BaseComponent) {
  _inherits(ContextualMenuItem, _BaseComponent);

  var _super = _createSuper(ContextualMenuItem);

  function ContextualMenuItem() {
    var _this;

    _classCallCheck(this, ContextualMenuItem);

    _this = _super.apply(this, arguments);

    _this.openSubMenu = function () {
      var _assertThisInitialize = _assertThisInitialized(_this),
          item = _assertThisInitialize.item,
          openSubMenu = _assertThisInitialize.openSubMenu;
    };

    return _this;
  }

  _createClass(ContextualMenuItem, [{
    key: "render",
    value: function render() {
      var h = arguments[0];
      var item = this.item,
          classNames = this.classNames;
      console.log(classNames);
      return h("button", {
        "class": classNames.root
      }, [h("div", {
        "class": item.split ? classNames.linkContentMenu : classNames.linkContent
      }, [this.renderCheckMarkIcon(this), this.renderItemIcon(this), this.renderItemName(this), this.renderSecondaryText(this), this.renderSubMenuIcon(this)])]);
    }
  }, {
    key: "dismissSubMenu",
    value: function dismissSubMenu() {}
  }, {
    key: "dismissMenu",
    value: function dismissMenu(dismissAll) {}
  }, {
    key: "renderItemIcon",
    value: function renderItemIcon(props) {
      var h = this.$createElement;
      var item = props.item,
          hasIcons = props.hasIcons,
          classNames = props.classNames;
      var iconProps = item.iconProps;

      if (!hasIcons) {
        return null;
      }

      if (item.onRenderIcon) {
        return item.onRenderIcon(props);
      }

      return h(Icon, _mergeJSXProps([{}, iconProps, {
        "class": classNames.icon
      }]));
    }
  }, {
    key: "renderCheckMarkIcon",
    value: function renderCheckMarkIcon(_ref) {
      var onCheckmarkClick = _ref.onCheckmarkClick,
          item = _ref.item,
          classNames = _ref.classNames;
      var h = this.$createElement;
      var isItemChecked = false;

      if (onCheckmarkClick) {
        var onClick = function onClick(e) {
          return onCheckmarkClick(item, e);
        };

        return h(Icon, {
          "attrs": {
            "icon-name": item.canCheck !== false && isItemChecked ? 'CheckMark' : '',
            "class-name": classNames.checkmarkIcon
          },
          "on": {
            "click": onClick
          }
        });
      }

      return null;
    }
  }, {
    key: "renderItemName",
    value: function renderItemName(_ref2) {
      var item = _ref2.item,
          classNames = _ref2.classNames;
      var h = this.$createElement;

      if (item.text || item.name) {
        return h("span", {
          "class": classNames.label
        }, [item.text || item.name]);
      }

      return null;
    }
  }, {
    key: "renderSecondaryText",
    value: function renderSecondaryText(_ref3) {
      var item = _ref3.item,
          classNames = _ref3.classNames;
      var h = this.$createElement;

      if (item.secondaryText) {
        return h("span", {
          "class": classNames.secondaryText
        }, [item.secondaryText]);
      }

      return null;
    }
  }, {
    key: "renderSubMenuIcon",
    value: function renderSubMenuIcon(_ref4) {
      var item = _ref4.item,
          classNames = _ref4.classNames,
          theme = _ref4.theme;
      return null;
    }
  }, {
    key: "classNames",
    get: function get() {
      return getClassNames(this.styles, {
        theme: this.theme
      });
    }
  }]);

  return ContextualMenuItem;
}(BaseComponent);

__decorate([Prop({
  type: Object,
  "default": function _default() {}
}), __metadata("design:type", Object)], ContextualMenuItem.prototype, "item", void 0);

ContextualMenuItem = __decorate([Component({
  components: {}
})], ContextualMenuItem);
var ContextualMenuItemBase = ContextualMenuItem;

export default ContextualMenuItemBase;
