import '../node_modules/core-js/modules/es.array.concat.js';
import '../node_modules/core-js/modules/es.date.to-string.js';
import '../node_modules/core-js/modules/es.object.to-string.js';
import '../node_modules/core-js/modules/es.reflect.construct.js';
import '../node_modules/core-js/modules/es.regexp.to-string.js';
import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent from '../BaseComponent.js';
import '../node_modules/core-js/modules/es.symbol.js';
import '../node_modules/core-js/modules/es.array.filter.js';
import '../node_modules/core-js/modules/es.array.for-each.js';
import '../node_modules/core-js/modules/es.object.define-properties.js';
import '../node_modules/core-js/modules/es.object.define-property.js';
import '../node_modules/core-js/modules/es.object.get-own-property-descriptor.js';
import '../node_modules/core-js/modules/es.object.get-own-property-descriptors.js';
import '../node_modules/core-js/modules/es.object.keys.js';
import '../node_modules/core-js/modules/web.dom-collections.for-each.js';
import _defineProperty from '@babel/runtime/helpers/defineProperty';
import '../node_modules/core-js/modules/es.array.map.js';
import '../node_modules/core-js/modules/es.array.slice.js';
import { List } from '../List/List.js';
import '../node_modules/core-js/modules/es.array.reduce.js';
import '../node_modules/core-js/modules/es.array.splice.js';
import _toConsumableArray from '@babel/runtime/helpers/toConsumableArray';
import _mergeJSXProps from '../node_modules/@vue/babel-helper-vue-jsx-merge-props/dist/helper.js';
import { DEFAULT_CELL_STYLE_PROPS } from './DetailsRow/DetailsRow.styles.js';
import './DetailsHeader/DetailsHeader.base.js';
import { DetailsHeader } from './DetailsHeader/DetailsHeader.js';
import './DetailsHeader/DetailsHeader.types.js';
import './DetailsRow/DetailsRowFields.js';
import './DetailsRow/DetailsRow.base.js';
import { DetailsRow } from './DetailsRow/DetailsRow.js';

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var getClassNames = classNamesFunction();

var DetailsListBase = function (_BaseComponent) {
  _inherits(DetailsListBase, _BaseComponent);

  var _super = _createSuper(DetailsListBase);

  function DetailsListBase() {
    var _this;

    _classCallCheck(this, DetailsListBase);

    _this = _super.apply(this, arguments);
    _this.lastWidth = -1;
    _this.lastSelectionMode = undefined;
    _this.columnOverrides = {};
    _this.lastSortedColumnKey = '';
    return _this;
  }

  _createClass(DetailsListBase, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var h = arguments[0];
      var classNames = this.classNames,
          items = this.items,
          adjustedColumns = this.adjustedColumns,
          compact = this.compact;
      return h("div", {
        "class": classNames.root,
        "attrs": {
          "data-is-scrollable": "false"
        }
      }, [h("div", {
        "attrs": {
          "role": "grid"
        }
      }, [h("div", {
        "class": classNames.headerWrapper
      }, [this.$scopedSlots.DetailsHeader ? this.$scopedSlots.DetailsHeader({
        defaultRender: this.onRenderDetailsHeader
      }) : this.onRenderDetailsHeader()]), h("div", {
        "class": classNames.contentWrapper
      }, [h(List, _mergeJSXProps([{
        "ref": "list",
        "attrs": {
          "items": items,
          "role": "presentation"
        }
      }, {
        scopedSlots: {
          item: function item(_ref) {
            var _item = _ref.item;
            return h(DetailsRow, _mergeJSXProps([{
              "attrs": {
                "item": _item,
                "columns": adjustedColumns,
                "compact": compact
              }
            }, {
              scopedSlots: _this2.$scopedSlots
            }]));
          }
        }
      }]))])])]);
    }
  }, {
    key: "onRenderDetailsHeader",
    value: function onRenderDetailsHeader() {
      var h = this.$createElement;
      return h(DetailsHeader, {
        "attrs": {
          "columns": this.adjustedColumns
        }
      });
    }
  }, {
    key: "created",
    value: function created() {
      var _this3 = this;

      var DEFAULT_COLUMN = {
        key: '',
        name: '',
        fieldName: '',
        className: '',
        styles: null,
        minWidth: 0,
        ariaLabel: '',
        isRowHeader: false,
        maxWidth: 0,
        columnActionsMode: 1,
        iconName: '',
        isIconOnly: false,
        iconClassName: '',
        isCollapsible: false,
        isSorted: false,
        isSortedDescending: false,
        isResizable: false,
        isMultiline: false,
        onRender: null,
        getValueKey: null,
        isFiltered: false,
        onColumnClick: null,
        onColumnContextMenu: null,
        onColumnResize: null,
        isGrouped: false,
        data: {},
        calculatedWidth: 0,
        currentWidth: 0,
        headerClassName: '',
        isPadded: false,
        sortAscendingAriaLabel: '',
        sortDescendingAriaLabel: '',
        groupAriaLabel: '',
        filterAriaLabel: '',
        isMenuOpen: false
      };

      var _loop = function _loop(key) {
        if (Object.prototype.hasOwnProperty.call(DEFAULT_COLUMN, key)) {
          var value = DEFAULT_COLUMN[key];

          _this3.columns.forEach(function (col) {
            _this3.$set(col, key, col[key] !== undefined ? col[key] : value);
          });
        }
      };

      for (var key in DEFAULT_COLUMN) {
        _loop(key);
      }
    }
  }, {
    key: "_rememberCalculatedWidth",
    value: function _rememberCalculatedWidth(column, newCalculatedWidth) {
      var overrides = this._getColumnOverride(column.key);

      overrides.calculatedWidth = newCalculatedWidth;
      overrides.currentWidth = newCalculatedWidth;
    }
  }, {
    key: "_getColumnOverride",
    value: function _getColumnOverride(key) {
      return this.columnOverrides[key] = this.columnOverrides[key] || {};
    }
  }, {
    key: "_adjustColumns",
    value: function _adjustColumns(newProps, forceUpdate, resizingColumnIndex) {
      var adjustedColumns = this._getAdjustedColumns(newProps, forceUpdate, resizingColumnIndex);

      var viewportWidth = 1000;

      if (adjustedColumns) {
        this.lastWidth = viewportWidth;
      }

      return adjustedColumns;
    }
  }, {
    key: "_getAdjustedColumns",
    value: function _getAdjustedColumns(newProps, forceUpdate, resizingColumnIndex) {
      var _this4 = this;

      var newItems = newProps.items,
          layoutMode = newProps.layoutMode,
          selectionMode = newProps.selectionMode,
          viewport = newProps.viewport;
      var viewportWidth = viewport && viewport.width ? viewport.width : 0;
      var newColumns = newProps.columns;
      var columns = this ? this.columns : [];
      var lastWidth = this ? this.lastWidth : -1;
      var lastSelectionMode = this ? this.lastSelectionMode : undefined;

      if (!forceUpdate && lastWidth === viewportWidth && lastSelectionMode === selectionMode && (!columns || newColumns === columns)) {
        return [];
      }

      newColumns = newColumns || buildColumns(newItems, true);
      var adjustedColumns;

      if (layoutMode !== 0) {
        adjustedColumns = this._getFixedColumns(newColumns);
        adjustedColumns.forEach(function (column) {
          _this4._rememberCalculatedWidth(column, column.calculatedWidth);
        });
      } else {
        if (resizingColumnIndex !== undefined) {
          adjustedColumns = this._getJustifiedColumnsAfterResize(newColumns, viewportWidth, newProps, resizingColumnIndex);
        } else {
          adjustedColumns = this._getJustifiedColumns(newColumns, viewportWidth, newProps, 0);
        }

        adjustedColumns.forEach(function (column) {
          _this4._getColumnOverride(column.key).currentWidth = column.calculatedWidth;
        });
      }

      return adjustedColumns;
    }
  }, {
    key: "_getFixedColumns",
    value: function _getFixedColumns(newColumns) {
      var _this5 = this;

      return newColumns.map(function (column) {
        var newColumn = _objectSpread(_objectSpread({}, column), _this5.columnOverrides[column.key]);

        if (!newColumn.calculatedWidth) {
          newColumn.calculatedWidth = newColumn.maxWidth || newColumn.minWidth || MIN_COLUMN_WIDTH;
        }

        return newColumn;
      });
    }
  }, {
    key: "_getJustifiedColumnsAfterResize",
    value: function _getJustifiedColumnsAfterResize(newColumns, viewportWidth, props, resizingColumnIndex) {
      var _this6 = this;

      var fixedColumns = newColumns.slice(0, resizingColumnIndex);
      fixedColumns.forEach(function (column) {
        return column.calculatedWidth = _this6._getColumnOverride(column.key).currentWidth;
      });
      var fixedWidth = fixedColumns.reduce(function (total, column, i) {
        return total + getPaddedWidth(column, i === 0, props);
      }, 0);
      var remainingColumns = newColumns.slice(resizingColumnIndex);
      var remainingWidth = viewportWidth - fixedWidth;
      return [].concat(_toConsumableArray(fixedColumns), _toConsumableArray(this._getJustifiedColumns(remainingColumns, remainingWidth, props, resizingColumnIndex)));
    }
  }, {
    key: "_getJustifiedColumns",
    value: function _getJustifiedColumns(newColumns, viewportWidth, props, firstIndex) {
      var _this7 = this;

      var _props$selectionMode = props.selectionMode,
          selectionMode = _props$selectionMode === void 0 ? 0 : _props$selectionMode,
          checkboxVisibility = props.checkboxVisibility;
      var rowCheckWidth = selectionMode !== 0 && checkboxVisibility !== checkboxVisibility.hidden ? 10 : 0;
      var groupExpandWidth = 1 * 10;
      var totalWidth = 0;
      var availableWidth = viewportWidth - (rowCheckWidth + groupExpandWidth);
      var adjustedColumns = newColumns.map(function (column, i) {
        var newColumn = _objectSpread(_objectSpread({}, column), {}, {
          calculatedWidth: column.minWidth || MIN_COLUMN_WIDTH
        }, _this7.columnOverrides[column.key]);

        var isFirst = i + firstIndex === 0;
        totalWidth += getPaddedWidth(newColumn, isFirst, props);
        return newColumn;
      });
      var lastIndex = adjustedColumns.length - 1;

      while (lastIndex > 0 && totalWidth > availableWidth) {
        var column = adjustedColumns[lastIndex];
        var minWidth = column.minWidth || MIN_COLUMN_WIDTH;
        var overflowWidth = totalWidth - availableWidth;

        if (column.calculatedWidth - minWidth >= overflowWidth || !(column.isCollapsible || column.isCollapsable)) {
          var originalWidth = column.calculatedWidth;
          column.calculatedWidth = Math.max(column.calculatedWidth - overflowWidth, minWidth);
          totalWidth -= originalWidth - column.calculatedWidth;
        } else {
          totalWidth -= getPaddedWidth(column, false, props);
          adjustedColumns.splice(lastIndex, 1);
        }

        lastIndex--;
      }

      for (var i = 0; i < adjustedColumns.length && totalWidth < availableWidth; i++) {
        var _column = adjustedColumns[i];
        var isLast = i === adjustedColumns.length - 1;
        var overrides = this.columnOverrides[_column.key];

        if (overrides && overrides.calculatedWidth && !isLast) {
          continue;
        }

        var spaceLeft = availableWidth - totalWidth;
        var increment = void 0;

        if (isLast) {
          increment = spaceLeft;
        } else {
          var maxWidth = _column.maxWidth;

          var _minWidth = _column.minWidth || maxWidth || MIN_COLUMN_WIDTH;

          increment = maxWidth ? Math.min(spaceLeft, maxWidth - _minWidth) : spaceLeft;
        }

        _column.calculatedWidth = _column.calculatedWidth + increment;
        totalWidth += increment;
      }

      return adjustedColumns;
    }
  }, {
    key: "classNames",
    get: function get() {
      var styles = this.styles,
          theme = this.theme,
          className = this.className,
          compact = this.compact;
      return getClassNames(styles, {
        theme: theme,
        compact: compact,
        isFixed: false,
        isHorizontalConstrained: false,
        className: className
      });
    }
  }, {
    key: "adjustedColumns",
    get: function get() {
      return this._adjustColumns(this.$props);
    }
  }]);

  return DetailsListBase;
}(BaseComponent);

__decorate([Prop({
  type: Array,
  required: true
}), __metadata("design:type", Array)], DetailsListBase.prototype, "columns", void 0);

__decorate([Prop({
  type: Array,
  "default": function _default() {
    return [];
  }
}), __metadata("design:type", Array)], DetailsListBase.prototype, "items", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], DetailsListBase.prototype, "compact", void 0);

DetailsListBase = __decorate([Component], DetailsListBase);
var MIN_COLUMN_WIDTH = 100;
function buildColumns(items, canResizeColumns, onColumnClick, sortedColumnKey, isSortedDescending, groupedColumnKey, isMultiline) {
  var columns = [];

  if (items && items.length) {
    var firstItem = items[0];

    for (var propName in firstItem) {
      if (Object.prototype.hasOwnProperty.call(firstItem, propName)) {
        columns.push({
          key: propName,
          name: propName,
          fieldName: propName,
          minWidth: MIN_COLUMN_WIDTH,
          maxWidth: 300,
          isCollapsable: !!columns.length,
          isCollapsible: !!columns.length,
          isMultiline: isMultiline === undefined ? false : isMultiline,
          isSorted: sortedColumnKey === propName,
          isSortedDescending: !!isSortedDescending,
          isRowHeader: false,
          columnActionsMode: 0,
          isResizable: canResizeColumns,
          onColumnClick: onColumnClick,
          isGrouped: groupedColumnKey === propName
        });
      }
    }
  }

  return columns;
}

function getPaddedWidth(column, isFirst, props) {
  var _props$cellStyleProps = props.cellStyleProps,
      cellStyleProps = _props$cellStyleProps === void 0 ? DEFAULT_CELL_STYLE_PROPS : _props$cellStyleProps;
  return column.calculatedWidth + cellStyleProps.cellLeftPadding + cellStyleProps.cellRightPadding + (column.isPadded ? cellStyleProps.cellExtraRightPadding : 0);
}

export { DetailsListBase, buildColumns };
