import { memoizeFunction } from '@uifabric-vue/utilities';
import { mergeStyleSets } from '@uifabric/styling';

var getDividerClassNames = memoizeFunction(function (theme) {
  return mergeStyleSets({
    wrapper: {
      display: 'inline-flex',
      height: '100%',
      alignItems: 'center'
    },
    divider: {
      width: 1,
      height: '100%',
      backgroundColor: theme.palette.neutralTertiaryAlt
    }
  });
});

export { getDividerClassNames };
