import '../node_modules/core-js/modules/es.date.to-string.js';
import '../node_modules/core-js/modules/es.object.to-string.js';
import '../node_modules/core-js/modules/es.reflect.construct.js';
import '../node_modules/core-js/modules/es.regexp.to-string.js';
import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { memoizeFunction, css } from '@uifabric-vue/utilities';
import { getIcon } from '@uifabric/styling';
import '../node_modules/core-js/modules/es.symbol.js';
import '../node_modules/core-js/modules/es.array.filter.js';
import '../node_modules/core-js/modules/es.array.for-each.js';
import '../node_modules/core-js/modules/es.object.define-properties.js';
import '../node_modules/core-js/modules/es.object.define-property.js';
import '../node_modules/core-js/modules/es.object.get-own-property-descriptor.js';
import '../node_modules/core-js/modules/es.object.get-own-property-descriptors.js';
import '../node_modules/core-js/modules/es.object.keys.js';
import '../node_modules/core-js/modules/web.dom-collections.for-each.js';
import _defineProperty from '@babel/runtime/helpers/defineProperty';
import StatelessComponent from '../StatelessComponent.js';
import { MS_ICON, classNames } from './Icon.styles.js';

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var getIconContent = memoizeFunction(function (iconName) {
  var _ref = getIcon(iconName) || {
    subset: {},
    code: undefined
  },
      code = _ref.code,
      subset = _ref.subset;

  if (!code) {
    return null;
  }

  return {
    children: code,
    iconClassName: subset.className,
    fontFamily: subset.fontFace && subset.fontFace.fontFamily
  };
}, undefined, true);

var FontIcon = function (_StatelessComponent) {
  _inherits(FontIcon, _StatelessComponent);

  var _super = _createSuper(FontIcon);

  function FontIcon() {
    _classCallCheck(this, FontIcon);

    return _super.apply(this, arguments);
  }

  _createClass(FontIcon, [{
    key: "render",
    value: function render(h, ctx) {
      var className = ctx.props.className || ctx.data["class"];
      var _ctx$props = ctx.props,
          iconName = _ctx$props.iconName,
          _ctx$props$style = _ctx$props.style,
          style = _ctx$props$style === void 0 ? {} : _ctx$props$style;
      var iconContent = getIconContent(iconName) || {};
      var children = iconContent.children;
      var iconClassName = iconContent.iconClassName,
          fontFamily = iconContent.fontFamily;
      return h("i", {
        "class": css(MS_ICON, classNames.root, iconClassName, !iconName && classNames.placeholder, className),
        "style": _objectSpread({
          fontFamily: fontFamily
        }, style)
      }, [typeof children === 'function' ? children(h) : children]);
    }
  }]);

  return FontIcon;
}(StatelessComponent);

__decorate([Prop({
  type: String,
  "default": ''
}), __metadata("design:type", String)], FontIcon.prototype, "iconName", void 0);

FontIcon = __decorate([Component], FontIcon);

export { FontIcon, getIconContent };
