import '../node_modules/core-js/modules/es.array.concat.js';
import '../node_modules/core-js/modules/es.date.to-string.js';
import '../node_modules/core-js/modules/es.object.to-string.js';
import '../node_modules/core-js/modules/es.reflect.construct.js';
import '../node_modules/core-js/modules/es.regexp.to-string.js';
import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate, __metadata } from 'tslib';
import { Prop, Watch, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent from '../BaseComponent.js';
import '../node_modules/core-js/modules/es.symbol.js';
import '../node_modules/core-js/modules/es.array.filter.js';
import '../node_modules/core-js/modules/es.array.for-each.js';
import '../node_modules/core-js/modules/es.array.join.js';
import '../node_modules/core-js/modules/es.function.name.js';
import '../node_modules/core-js/modules/es.object.define-properties.js';
import '../node_modules/core-js/modules/es.object.define-property.js';
import '../node_modules/core-js/modules/es.object.get-own-property-descriptor.js';
import '../node_modules/core-js/modules/es.object.get-own-property-descriptors.js';
import '../node_modules/core-js/modules/es.object.keys.js';
import '../node_modules/core-js/modules/web.dom-collections.for-each.js';
import _defineProperty from '@babel/runtime/helpers/defineProperty';
import '../node_modules/core-js/modules/es.symbol.description.js';
import '../node_modules/core-js/modules/es.symbol.iterator.js';
import '../node_modules/core-js/modules/es.array.from.js';
import '../node_modules/core-js/modules/es.array.is-array.js';
import '../node_modules/core-js/modules/es.array.iterator.js';
import '../node_modules/core-js/modules/es.array.map.js';
import '../node_modules/core-js/modules/es.array.slice.js';
import '../node_modules/core-js/modules/es.number.constructor.js';
import '../node_modules/core-js/modules/es.string.iterator.js';
import '../node_modules/core-js/modules/web.dom-collections.iterator.js';
import '../node_modules/core-js/modules/es.string.small.js';
import '../node_modules/core-js/modules/es.array.reduce.js';
import '@babel/runtime/helpers/toConsumableArray';
import _mergeJSXProps from '../node_modules/@vue/babel-helper-vue-jsx-merge-props/dist/helper.js';
import { Icon } from '../Icon/index.js';
import '../Layer/Layer.base.js';
import { Layer } from '../Layer/Layer.js';
import '../Layer/LayerHost.js';
import { DirectionalHint } from '../../common/DirectionalHint.js';
import '../../utilities/positioning/positioning.types.js';
import '../../utilities/positioning/positioning.js';
import '../Callout/Callout.js';
import '../node_modules/core-js/modules/es.regexp.exec.js';
import '../node_modules/core-js/modules/es.string.split.js';
import { Overlay } from '../Overlay/Overlay.js';
import '../../utilities/grid/Grid.js';
import '../../utilities/grid/GridCell.js';
import '../../utilities/color/shades.js';
import '../node_modules/core-js/modules/es.parse-int.js';
import '../node_modules/core-js/modules/es.string.match.js';
import '../node_modules/core-js/modules/es.string.trim.js';
import '../../utilities/keytips/IKeytipTransitionKey.js';
import '../../utilities/keytips/KeytipConstants.js';
import '../../utilities/keytips/KeytipManager.js';
import '../node_modules/core-js/modules/es.string.replace.js';
import { ResponsiveMode } from '../../utilities/responsiveMode.js';
import '../../utilities/selectableOption/SelectableOption.types.js';
import { Popup } from '../Popup/Popup.js';

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var getClassNames = classNamesFunction();
var DefaultLayerProps = {
  eventBubblingEnabled: false
};

var ModalBase = function (_BaseComponent) {
  _inherits(ModalBase, _BaseComponent);

  var _super = _createSuper(ModalBase);

  function ModalBase() {
    var _this;

    _classCallCheck(this, ModalBase);

    _this = _super.apply(this, arguments);
    _this.internalIsOpen = false;
    _this.isVisible = false;
    _this.isVisibleClose = false;
    _this.hasBeenOpened = false;
    _this.modalRectangleTop = 0;
    _this.isModalMenuOpen = false;
    _this.isInKeyboardMoveMode = false;
    _this.x = 0;
    _this.y = 0;
    _this.lastSetX = 0;
    _this.lastSetY = 0;
    _this.responsiveMode = ResponsiveMode.large;
    return _this;
  }

  _createClass(ModalBase, [{
    key: "onIsOpenChanged",
    value: function onIsOpenChanged(newVal) {
      if (newVal) this.isVisible = true;
    }
  }, {
    key: "onModalContextMenuClose",
    value: function onModalContextMenuClose() {
      this.isModalMenuOpen = false;
    }
  }, {
    key: "onModalClose",
    value: function onModalClose() {
      this.isModalMenuOpen = false;
      this.isInKeyboardMoveMode = false;
      this.isOpen = false;
    }
  }, {
    key: "onEnterKeyboardMoveMode",
    value: function onEnterKeyboardMoveMode() {
      this.lastSetX = this.x;
      this.lastSetY = this.y;
      this.isInKeyboardMoveMode = true;
      this.isModalMenuOpen = true;
    }
  }, {
    key: "_onDragStart",
    value: function _onDragStart() {
      this.isModalMenuOpen = false;
      this.isInKeyboardMoveMode = false;
    }
  }, {
    key: "_onDrag",
    value: function _onDrag(_, ui) {
      this.x += ui.delta.x;
      this.y += ui.delta.y;
    }
  }, {
    key: "_onDragStop",
    value: function _onDragStop() {}
  }, {
    key: "onDismiss",
    value: function onDismiss(ev) {
      this.$emit('dismiss', ev);
    }
  }, {
    key: "render",
    value: function render() {
      var h = arguments[0];
      var dragOptions = this.dragOptions,
          isInKeyboardMoveMode = this.isInKeyboardMoveMode,
          classNames = this.classNames,
          isOpen = this.isOpen,
          responsiveMode = this.responsiveMode,
          isModeless = this.isModeless,
          layerProps = this.layerProps,
          isBlocking = this.isBlocking,
          titleAriaId = this.titleAriaId,
          subtitleAriaId = this.subtitleAriaId,
          isDarkOverlay = this.isDarkOverlay,
          onDismiss = this.onDismiss,
          overlay = this.overlay,
          ignoreExternalFocusing = this.ignoreExternalFocusing,
          x = this.x,
          y = this.y;
      if (!isOpen) return null;

      var mergedLayerProps = _objectSpread(_objectSpread(_objectSpread({}, DefaultLayerProps), this.layerProps), {}, {
        onLayerDidMount: layerProps && layerProps.onLayerDidMount,
        insertFirst: isModeless,
        className: classNames.layer
      });

      var modalContent = h("div", {
        "class": classNames.main
      }, [dragOptions && isInKeyboardMoveMode && h("div", {
        "class": classNames.keyboardMoveIconContainer
      }, [dragOptions.keyboardMoveIconProps ? h(Icon, _mergeJSXProps([{}, dragOptions.keyboardMoveIconProps])) : h(Icon, {
        "attrs": {
          "iconName": "move"
        },
        "class": classNames.keyboardMoveIcon
      })]), h("div", {
        "ref": "scrollableContent",
        "class": classNames.scrollableContent,
        "attrs": {
          "data-is-scrollable": true
        }
      }, [dragOptions && this.isModalMenuOpen && h(dragOptions.menu, {
        "attrs": {
          "items": [{
            key: 'move',
            text: dragOptions.moveMenuItemText,
            onClick: this.onEnterKeyboardMoveMode
          }, {
            key: 'close',
            text: dragOptions.closeMenuItemText,
            onClick: this.onModalClose
          }],
          "alignTargetEdge": true,
          "coverTarget": true,
          "directionalHint": DirectionalHint.topLeftEdge,
          "directionalHintFixed": true,
          "shouldFocusOnMount": true,
          "target": this.$refs.scrollableContent
        },
        "on": {
          "dismiss": this.onModalContextMenuClose
        }
      }), this.$slots["default"]])]);

      if (responsiveMode >= ResponsiveMode.small) {
        return h(Layer, _mergeJSXProps([{}, mergedLayerProps]), [h(Popup, {
          "attrs": {
            "role": isModeless || !isBlocking ? 'dialog' : 'alertdialog',
            "aria-modal": !isModeless,
            "ariaLabelledBy": titleAriaId,
            "ariaDescribedBy": subtitleAriaId,
            "shouldRestoreFocus": !ignoreExternalFocusing
          },
          "on": {
            "dismiss": onDismiss
          }
        }, [h("div", {
          "class": classNames.root
        }, [!isModeless && h(Overlay, {
          "attrs": {
            "dark": isDarkOverlay,
            "allowTouchBodyScroll": this.allowTouchBodyScroll
          },
          "on": {
            "click": isBlocking ? undefined : onDismiss
          },
          "props": _objectSpread({}, overlay)
        }), dragOptions ? modalContent : modalContent])])]);
      }
    }
  }, {
    key: "classNames",
    get: function get() {
      var theme = this.theme,
          styles = this.styles,
          className = this.className,
          layerProps = this.layerProps,
          containerClassName = this.containerClassName,
          scrollableContentClassName = this.scrollableContentClassName,
          isVisible = this.isVisible,
          hasBeenOpened = this.hasBeenOpened,
          modalRectangleTop = this.modalRectangleTop,
          topOffsetFixed = this.topOffsetFixed,
          isModeless = this.isModeless,
          dragOptions = this.dragOptions,
          isOpen = this.isOpen;
      var layerClassName = layerProps == null ? '' : layerProps.className;
      return getClassNames(styles, {
        theme: theme,
        className: className,
        containerClassName: containerClassName,
        scrollableContentClassName: scrollableContentClassName,
        isOpen: isOpen,
        isVisible: isVisible,
        hasBeenOpened: hasBeenOpened,
        modalRectangleTop: modalRectangleTop,
        topOffsetFixed: topOffsetFixed,
        isModeless: isModeless,
        layerClassName: layerClassName,
        isDefaultDragHandle: dragOptions && !dragOptions.dragHandleSelector
      });
    }
  }]);

  return ModalBase;
}(BaseComponent);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], ModalBase.prototype, "isOpen", void 0);

__decorate([Prop({
  type: Boolean,
  "default": true
}), __metadata("design:type", Boolean)], ModalBase.prototype, "isDarkOverlay", void 0);

__decorate([Prop({
  type: Function,
  "default": null
}), __metadata("design:type", Function)], ModalBase.prototype, "onDismissed", void 0);

__decorate([Prop({
  type: Object,
  "default": null
}), __metadata("design:type", Object)], ModalBase.prototype, "layerProps", void 0);

__decorate([Prop({
  type: Object,
  "default": null
}), __metadata("design:type", Object)], ModalBase.prototype, "overlay", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], ModalBase.prototype, "isBlocking", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], ModalBase.prototype, "isModeless", void 0);

__decorate([Prop({
  type: String,
  "default": ''
}), __metadata("design:type", String)], ModalBase.prototype, "className", void 0);

__decorate([Prop({
  type: String,
  "default": ''
}), __metadata("design:type", String)], ModalBase.prototype, "containerClassName", void 0);

__decorate([Prop({
  type: String,
  "default": ''
}), __metadata("design:type", String)], ModalBase.prototype, "scrollableContentClassName", void 0);

__decorate([Prop({
  type: String,
  "default": ''
}), __metadata("design:type", String)], ModalBase.prototype, "titleAriaId", void 0);

__decorate([Prop({
  type: String,
  "default": ''
}), __metadata("design:type", String)], ModalBase.prototype, "subtitleAriaId", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], ModalBase.prototype, "topOffsetFixed", void 0);

__decorate([Prop({
  type: Object,
  "default": null
}), __metadata("design:type", Object)], ModalBase.prototype, "dragOptions", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], ModalBase.prototype, "allowTouchBodyScroll", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], ModalBase.prototype, "ignoreExternalFocusing", void 0);

__decorate([Watch('isOpen'), __metadata("design:type", Function), __metadata("design:paramtypes", [Object]), __metadata("design:returntype", void 0)], ModalBase.prototype, "onIsOpenChanged", null);

ModalBase = __decorate([Component], ModalBase);

export { ModalBase };
