import '../node_modules/core-js/modules/es.date.to-string.js';
import '../node_modules/core-js/modules/es.object.to-string.js';
import '../node_modules/core-js/modules/es.reflect.construct.js';
import '../node_modules/core-js/modules/es.regexp.to-string.js';
import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent from '../BaseComponent.js';
import '../node_modules/core-js/modules/es.array.map.js';

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var getClassNames = classNamesFunction();

var OverflowSetBase = function (_BaseComponent) {
  _inherits(OverflowSetBase, _BaseComponent);

  var _super = _createSuper(OverflowSetBase);

  function OverflowSetBase() {
    _classCallCheck(this, OverflowSetBase);

    return _super.apply(this, arguments);
  }

  _createClass(OverflowSetBase, [{
    key: "render",
    value: function render() {
      var _this = this;

      var h = arguments[0];
      var classNames = this.classNames,
          items = this.items,
          overflowItems = this.overflowItems;
      return h("div", {
        "class": classNames.root
      }, [items.map(function (item, index) {
        return h("div", {
          "key": index,
          "class": classNames.item
        }, [_this.$scopedSlots.item && _this.$scopedSlots.item({
          item: item
        })]);
      }), overflowItems && overflowItems.length > 0 && h("div", {
        "class": classNames.overflowButton
      }, [this.$scopedSlots.overflow && this.$scopedSlots.overflow({
        items: overflowItems
      })])]);
    }
  }, {
    key: "classNames",
    get: function get() {
      var styles = this.styles,
          className = this.className,
          vertical = this.vertical;
      return getClassNames(styles, {
        className: className,
        vertical: vertical
      });
    }
  }]);

  return OverflowSetBase;
}(BaseComponent);

__decorate([Prop({
  type: Array,
  "default": function _default() {
    return [];
  }
}), __metadata("design:type", Array)], OverflowSetBase.prototype, "items", void 0);

__decorate([Prop({
  type: Array,
  "default": function _default() {
    return [];
  }
}), __metadata("design:type", Array)], OverflowSetBase.prototype, "overflowItems", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], OverflowSetBase.prototype, "vertical", void 0);

OverflowSetBase = __decorate([Component({
  components: {}
})], OverflowSetBase);

export { OverflowSetBase };
