import '../node_modules/core-js/modules/es.string.small.js';

var PersonaSize;

(function (PersonaSize) {
  PersonaSize[PersonaSize["tiny"] = 0] = "tiny";
  PersonaSize[PersonaSize["extraExtraSmall"] = 1] = "extraExtraSmall";
  PersonaSize[PersonaSize["extraSmall"] = 2] = "extraSmall";
  PersonaSize[PersonaSize["small"] = 3] = "small";
  PersonaSize[PersonaSize["regular"] = 4] = "regular";
  PersonaSize[PersonaSize["large"] = 5] = "large";
  PersonaSize[PersonaSize["extraLarge"] = 6] = "extraLarge";
  PersonaSize[PersonaSize["size8"] = 17] = "size8";
  PersonaSize[PersonaSize["size10"] = 9] = "size10";
  PersonaSize[PersonaSize["size16"] = 8] = "size16";
  PersonaSize[PersonaSize["size24"] = 10] = "size24";
  PersonaSize[PersonaSize["size28"] = 7] = "size28";
  PersonaSize[PersonaSize["size32"] = 11] = "size32";
  PersonaSize[PersonaSize["size40"] = 12] = "size40";
  PersonaSize[PersonaSize["size48"] = 13] = "size48";
  PersonaSize[PersonaSize["size56"] = 16] = "size56";
  PersonaSize[PersonaSize["size72"] = 14] = "size72";
  PersonaSize[PersonaSize["size100"] = 15] = "size100";
  PersonaSize[PersonaSize["size120"] = 18] = "size120";
})(PersonaSize || (PersonaSize = {}));

var PersonaPresence;

(function (PersonaPresence) {
  PersonaPresence[PersonaPresence["none"] = 0] = "none";
  PersonaPresence[PersonaPresence["offline"] = 1] = "offline";
  PersonaPresence[PersonaPresence["online"] = 2] = "online";
  PersonaPresence[PersonaPresence["away"] = 3] = "away";
  PersonaPresence[PersonaPresence["dnd"] = 4] = "dnd";
  PersonaPresence[PersonaPresence["blocked"] = 5] = "blocked";
  PersonaPresence[PersonaPresence["busy"] = 6] = "busy";
})(PersonaPresence || (PersonaPresence = {}));

var PersonaInitialsColor;

(function (PersonaInitialsColor) {
  PersonaInitialsColor[PersonaInitialsColor["lightBlue"] = 0] = "lightBlue";
  PersonaInitialsColor[PersonaInitialsColor["blue"] = 1] = "blue";
  PersonaInitialsColor[PersonaInitialsColor["darkBlue"] = 2] = "darkBlue";
  PersonaInitialsColor[PersonaInitialsColor["teal"] = 3] = "teal";
  PersonaInitialsColor[PersonaInitialsColor["lightGreen"] = 4] = "lightGreen";
  PersonaInitialsColor[PersonaInitialsColor["green"] = 5] = "green";
  PersonaInitialsColor[PersonaInitialsColor["darkGreen"] = 6] = "darkGreen";
  PersonaInitialsColor[PersonaInitialsColor["lightPink"] = 7] = "lightPink";
  PersonaInitialsColor[PersonaInitialsColor["pink"] = 8] = "pink";
  PersonaInitialsColor[PersonaInitialsColor["magenta"] = 9] = "magenta";
  PersonaInitialsColor[PersonaInitialsColor["purple"] = 10] = "purple";
  PersonaInitialsColor[PersonaInitialsColor["black"] = 11] = "black";
  PersonaInitialsColor[PersonaInitialsColor["orange"] = 12] = "orange";
  PersonaInitialsColor[PersonaInitialsColor["red"] = 13] = "red";
  PersonaInitialsColor[PersonaInitialsColor["darkRed"] = 14] = "darkRed";
  PersonaInitialsColor[PersonaInitialsColor["transparent"] = 15] = "transparent";
  PersonaInitialsColor[PersonaInitialsColor["violet"] = 16] = "violet";
  PersonaInitialsColor[PersonaInitialsColor["lightRed"] = 17] = "lightRed";
  PersonaInitialsColor[PersonaInitialsColor["gold"] = 18] = "gold";
  PersonaInitialsColor[PersonaInitialsColor["burgundy"] = 19] = "burgundy";
  PersonaInitialsColor[PersonaInitialsColor["warmGray"] = 20] = "warmGray";
  PersonaInitialsColor[PersonaInitialsColor["coolGray"] = 21] = "coolGray";
  PersonaInitialsColor[PersonaInitialsColor["gray"] = 22] = "gray";
  PersonaInitialsColor[PersonaInitialsColor["cyan"] = 23] = "cyan";
  PersonaInitialsColor[PersonaInitialsColor["rust"] = 24] = "rust";
})(PersonaInitialsColor || (PersonaInitialsColor = {}));

export { PersonaInitialsColor, PersonaPresence, PersonaSize };
