import { styled } from '../styled.js';
export { PersonaInitialsColor, PersonaPresence, PersonaSize } from './Persona.types.js';
export { getPersonaInitialsColor } from './PersonaInitialsColor.js';
export { personaPresenceSize, personaSize, presenceBoolean, sizeBoolean, sizeToPixels } from './PersonaConsts.js';
export { PersonaCoin } from './PersonaCoin/index.js';
import { PersonaBase } from './Persona.base.js';
import { getStyles } from './Persona.styles.js';

var Persona = styled(PersonaBase, getStyles, undefined, {
  scope: 'Persona'
});

export { Persona };
