import '../node_modules/core-js/modules/es.date.to-string.js';
import '../node_modules/core-js/modules/es.object.to-string.js';
import '../node_modules/core-js/modules/es.reflect.construct.js';
import '../node_modules/core-js/modules/es.regexp.to-string.js';
import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import StatelessComponent from '../StatelessComponent.js';

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var getClassNames = classNamesFunction();

var SeparatorBase = function (_StatelessComponent) {
  _inherits(SeparatorBase, _StatelessComponent);

  var _super = _createSuper(SeparatorBase);

  function SeparatorBase() {
    _classCallCheck(this, SeparatorBase);

    return _super.apply(this, arguments);
  }

  _createClass(SeparatorBase, [{
    key: "render",
    value: function render(h, context) {
      var _context$props = context.props,
          styles = _context$props.styles,
          theme = _context$props.theme,
          className = _context$props.className,
          vertical = _context$props.vertical,
          alignContent = _context$props.alignContent;
      var classNames = getClassNames(styles, {
        theme: theme,
        className: className,
        alignContent: alignContent,
        vertical: vertical
      });
      return h("div", {
        "class": classNames.root
      }, [h("div", {
        "class": classNames.content,
        "attrs": {
          "role": "separator",
          "aria-orientation": vertical ? 'vertical' : 'horizontal'
        }
      }, [context.children])]);
    }
  }]);

  return SeparatorBase;
}(StatelessComponent);

__decorate([Prop({
  type: String,
  "default": 'center'
}), __metadata("design:type", String)], SeparatorBase.prototype, "alignContent", void 0);

__decorate([Prop({
  type: Boolean,
  "default": false
}), __metadata("design:type", Boolean)], SeparatorBase.prototype, "vertical", void 0);

SeparatorBase = __decorate([Component], SeparatorBase);

export { SeparatorBase };
