import '../../node_modules/core-js/modules/es.date.to-string.js';
import '../../node_modules/core-js/modules/es.object.to-string.js';
import '../../node_modules/core-js/modules/es.reflect.construct.js';
import '../../node_modules/core-js/modules/es.regexp.to-string.js';
import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate } from 'tslib';
import { Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import StatelessComponent from '../../StatelessComponent.js';
import { ShimmerElementsDefaultHeights } from '../Shimmer.types.js';
import { ShimmerLine } from '../ShimmerLine/ShimmerLine.js';

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var getClassNames = classNamesFunction();

var ShimmerElementsGroupBase = function (_StatelessComponent) {
  _inherits(ShimmerElementsGroupBase, _StatelessComponent);

  var _super = _createSuper(ShimmerElementsGroupBase);

  function ShimmerElementsGroupBase() {
    _classCallCheck(this, ShimmerElementsGroupBase);

    return _super.apply(this, arguments);
  }

  _createClass(ShimmerElementsGroupBase, [{
    key: "render",
    value: function render(h, ctx) {
      var _ctx$props = ctx.props,
          styles = _ctx$props.styles,
          theme = _ctx$props.theme;
      var classNames = getClassNames(styles, {
        theme: theme
      });
      return h("div", {
        "class": classNames.root
      }, [h("shimmer-line", {
        "attrs": {
          "height": ShimmerElementsDefaultHeights.line
        }
      })]);
    }
  }]);

  return ShimmerElementsGroupBase;
}(StatelessComponent);

ShimmerElementsGroupBase = __decorate([Component({
  components: {
    ShimmerLine: ShimmerLine
  }
})], ShimmerElementsGroupBase);
var ShimmerElementsGroupBase$1 = ShimmerElementsGroupBase;

export default ShimmerElementsGroupBase$1;
