import '../../node_modules/core-js/modules/es.date.to-string.js';
import '../../node_modules/core-js/modules/es.object.to-string.js';
import '../../node_modules/core-js/modules/es.reflect.construct.js';
import '../../node_modules/core-js/modules/es.regexp.to-string.js';
import _classCallCheck from '@babel/runtime/helpers/classCallCheck';
import _createClass from '@babel/runtime/helpers/createClass';
import _inherits from '@babel/runtime/helpers/inherits';
import _possibleConstructorReturn from '@babel/runtime/helpers/possibleConstructorReturn';
import _getPrototypeOf from '@babel/runtime/helpers/getPrototypeOf';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import StatelessComponent from '../../StatelessComponent.js';
import '../../node_modules/core-js/modules/es.number.constructor.js';

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var getClassNames = classNamesFunction();

var ShimmerLineBase = function (_StatelessComponent) {
  _inherits(ShimmerLineBase, _StatelessComponent);

  var _super = _createSuper(ShimmerLineBase);

  function ShimmerLineBase() {
    _classCallCheck(this, ShimmerLineBase);

    return _super.apply(this, arguments);
  }

  _createClass(ShimmerLineBase, [{
    key: "render",
    value: function render(h, ctx) {
      var _ctx$props = ctx.props,
          height = _ctx$props.height,
          styles = _ctx$props.styles,
          _ctx$props$width = _ctx$props.width,
          width = _ctx$props$width === void 0 ? '100%' : _ctx$props$width,
          borderStyle = _ctx$props.borderStyle,
          theme = _ctx$props.theme;
      var classNames = getClassNames(styles, {
        theme: theme,
        height: height,
        borderStyle: borderStyle
      });
      return h("div", {
        "style": {
          width: width,
          minWidth: typeof width === 'number' ? "".concat(width, "px") : 'auto'
        },
        "class": classNames.root
      }, [h("svg", {
        "attrs": {
          "width": "2",
          "height": "2"
        },
        "class": classNames.topLeftCorner
      }, [h("path", {
        "attrs": {
          "d": "M0 2 A 2 2, 0, 0, 1, 2 0 L 0 0 Z"
        }
      })]), h("svg", {
        "attrs": {
          "width": "2",
          "height": "2"
        },
        "class": classNames.topRightCorner
      }, [h("path", {
        "attrs": {
          "d": "M0 0 A 2 2, 0, 0, 1, 2 2 L 2 0 Z"
        }
      })]), h("svg", {
        "attrs": {
          "width": "2",
          "height": "2"
        },
        "class": classNames.bottomRightCorner
      }, [h("path", {
        "attrs": {
          "d": "M2 0 A 2 2, 0, 0, 1, 0 2 L 2 2 Z"
        }
      })]), h("svg", {
        "attrs": {
          "width": "2",
          "height": "2"
        },
        "class": classNames.bottomLeftCorner
      }, [h("path", {
        "attrs": {
          "d": "M2 2 A 2 2, 0, 0, 1, 0 0 L 0 2 Z"
        }
      })])]);
    }
  }]);

  return ShimmerLineBase;
}(StatelessComponent);

__decorate([Prop({
  type: Number,
  "default": 0
}), __metadata("design:type", Number)], ShimmerLineBase.prototype, "height", void 0);

ShimmerLineBase = __decorate([Component], ShimmerLineBase);
var ShimmerLineBase$1 = ShimmerLineBase;

export default ShimmerLineBase$1;
