import { __decorate } from "tslib";
import { Component } from 'vue-property-decorator';
import { getStyles } from './MessageBarButton.styles';
import BaseComponent from '../../BaseComponent';
import { DefaultButton } from '../DefaultButton/DefaultButton';
import { BaseButton } from '../BaseButton';
let MessageBarButton = class MessageBarButton extends BaseComponent {
    get internalStyles() {
        return getStyles(this.theme, this.styles);
    }
    render() {
        const { internalStyles } = this;
        const props = {
            variantClassName: 'ms-Button--icon',
            styles: internalStyles,
        };
        return (<BaseButton {...{ props, attrs: this.$attrs }}>
        {this.$slots.default}
      </BaseButton>);
    }
};
MessageBarButton = __decorate([
    Component({
        components: { DefaultButton },
    })
], MessageBarButton);
export { MessageBarButton };
//# sourceMappingURL=MessageBarButton.jsx.map