import { __decorate, __metadata } from "tslib";
import { Component, Prop } from 'vue-property-decorator';
import { notifyHostChanged } from './Layer.notification';
import BaseComponent from '../BaseComponent';
let LayerHost = class LayerHost extends BaseComponent {
    render() {
        return (<div id={this.hostId} class="LayerHost"/>);
    }
    mounted() {
        notifyHostChanged(this.hostId);
    }
    beforeDestroy() {
        notifyHostChanged(this.hostId);
    }
};
__decorate([
    Prop({ type: String, default: null }),
    __metadata("design:type", String)
], LayerHost.prototype, "hostId", void 0);
LayerHost = __decorate([
    Component({
        components: {},
    })
], LayerHost);
export { LayerHost };
//# sourceMappingURL=LayerHost.jsx.map